/*
  ECCX08 Random Number

  This sketch uses the ECC508 or ECC608 to generate a random number 
  every second and print it to the Serial monitor

  Circuit:
   - MKR board with ECC508 or ECC608 on board

  created 19 July 2018
  by Sandeep Mistry
*/

#include <ArduinoECCX08.h>
#include <Wire.h>
#include "ECCX08.h"


byte mydata[128];

void setup() {
  Serial.begin(9600);
  while (!Serial);

  for(int i = 0; i < 128; i++)
  {
    int j=i;
    if (j>=250){
      j=j-250;
    }
    mydata[i]=j;
  }

  Serial.println("ready");
  delay(100);
  int didRun=0;
  didRun = ECCX08.readConfiguration(mydata);

  Serial.println("Showing config as HEX:index");
  for(int i = 0; i < 128; i++)
  {
    char my_data[2];

    sprintf(my_data,"%02X",mydata[i]);
    Serial.print(my_data);
    
    //Serial.print(mydata[i], HEX);
    Serial.print(":");
    Serial.print(i);
    Serial.print(", ");
  }
  Serial.println();

  if(didRun){
    Serial.println("readConfiguration returned true");
  } else {
    Serial.println("There was a problem, readConfiguration returned false");
  }
  Serial.println("done");


  //Output char array
  Serial.print("{");
  for(int i = 0; i < 128; i++)
  { Serial.print(mydata[i]);
    if (i!=127){
      Serial.print(",");
    }
  }
   Serial.println("}");
  
  if (!ECCX08.begin()) {
    Serial.println("Failed to communicate with ECC508/ECC608!");
    while (1);
  }

  Serial.print("Did run result: ");
  Serial.println(didRun);

  if (!ECCX08.locked()) {
    Serial.println("The ECC508/ECC608 is not locked!");
    while (1);
  }
}

void loop() {
  Serial.print("Setting up version");
 // Serial.println(ECCX08.version());

  delay(1000);
}
